﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

if __name__ == '__main__':
    import notecalc
    exit()

import re
import string

#debugging
import pdb

class variable:

    def __init__(self,config):
        self.DicoVar = {}
        self.config = config
        self.signeRe = '\+|\-|\*|\/|\^|\²|\(|\)|\[|\]|\{|\}|sqrt|sin|cos|tan|asin|acos|atan'


    def number(self,name):
        return len(self.DicoVar[name])


    def find(self,s):
        '''Prend la chaine "formule arithmétique" et retourne une chaine "formule numérique"'''

        print 'recherche et remplace les variable dans la chaine %s' %s
        print 'Les variable se trouve dans %s' %self.DicoVar

        recherche = re.search('[a-zA-Z]',s)
        print recherche
        deb = None
        new_s = ''

        while recherche:
            print " une lettre à été trouvée"
            deb = recherche.start()
            fin = deb
            nameVar = ''
            finMax = len(s)
            while (s[fin].isalnum()):
                print " Composition du nom de la variable"
                nameVar += s[fin]
                print nameVar
                fin += 1
                print "%s/%s" %(fin, finMax)
                if (fin == finMax):
                    print "fin plus gd que max"
                    break

            #Cherche la variable dans le DicoVariables
            Var = self.read(nameVar)

            if Var:
                new_s += s[0:deb] + str(Var) + s[fin:]
                s = s[fin:]
                print "Chaine pour la recherche : %s" %s
                print "Chaine en construction : %s" %new_s
            else:
                break

            recherche = re.search('[a-zA-Z]',s)

        if new_s == '':
            print 'ancune variable dans le calcul'
            new_s = s

        return new_s


    def write(self,name,value=None):
        '''Stocker la référence des lignes qui contien le resultat de la variable'''

        #if name == None:
        #    return self.DicoVar
        #self.DicoVar
        name = name.strip()

        if name in self.DicoVar:
            if not value in self.DicoVar[name]:
                self.DicoVar[name].append(value)
        else:
            self.DicoVar[name] = [value]
        print "nouveau dico : %s" %self.DicoVar


    def read(self,nameVar):
        '''Grace au nom trouve la valeur de la variable'''
        self.DicoVar

        print '*** Fonction lecture variable ***'
        print 'variable %s à chercher dans %s' %(nameVar,self.DicoVar)

        nameVar = nameVar.strip()

        if nameVar in self.DicoVar:
            lenVar = len(self.DicoVar[nameVar])
            if len == 1 :
                print 'il n\'y a qu\'une variable nomée "%s"' %nameVar
                clefVar = 0
            else:
                print 'il y a %s variable nomée "%s"' % (lenVar,nameVar)
                #clefVar = lenVar - 1
            Var = self.DicoVar[nameVar]
            print " les ids ou chercher la variable %s sont %s" %(nameVar,Var)
            #s = s[0:deb] + str(DicoVariables[nameVar]) + s[fin:]
            #new_s += s[0:deb] + 'DicoVar[\''+nameVar+'\']['+str(clefVar)+']' + s[fin:]
            return Var
        else:
            print self.DicoVar
            #new_s = ' Aucune variable "%s" trouvée dans %s' %(nameVar,self.DicoVar)
            return 0


    def nameVarInEndChar(self,char):
        '''Recherche le nom de la dernière variable de la chaine
        retourne une liste (nameVar,Position dans la chaine)'''
        #Supprimer les espaces en fin de ligne
        #pdb.set_trace()
        while not char[-1:].isalpha():
            char = char[:-1]
            if char == '':
                break
        #Recherche depuis la fin le 1er caractère non alphanumérique
        i = len(char) - 1
        while char[i:i+1].isalpha():
            i-=1
            print i
            if i == 0:
                break
        #Construction du nom de la variable
        nameVar = char[i:]

        if nameVar == '':
            return (None,i)
        else:
            print 'la derniere variable de la chaine "%s" est "%s" à la position : %s' %(char,nameVar,i +1)
            return (nameVar,i +1)


    def findVars(self,char):
        '''Recherche toutes les variables d'une chaine, retrourne un liste :
        ((nameVar,posdeb,pasfin),(...),...)'''

        deb = 0
        listVar = []
        list4eval = []

        #Recherche de oppérateur
        #pdb.set_trace()
        for match in re.finditer(self.signeRe,char):
            fin = match.start(0)
            print "deb = %s | fin + %s" %(deb,fin)

            if not deb == fin: #pour lessignes d'opérations sans espace entre eux (², **)
                nameVar = char[deb:fin]
                #Si la variable commence par une lettre, c'est une variables
                print "nameVar %s :" %nameVar
                if not re.match('[0-9]|\.',nameVar[0]): #si le 1er charactère n'est pas un chiffre ou un point
                                                        #alors c'est une variable
                    print "   est une variable (commence par une lettre)"
                    listVar.append((nameVar,deb,fin))
                    list4eval.extend(("var['",nameVar,"']")) #création de la liste qui serira à la nouvelle chaine
                else :
                    print "   n'est pas une variable (ne commence pas par une lettre)"
                    list4eval.append(nameVar) #idem si c'est pas une variable
            deb = match.end(0)
            list4eval.append(char[fin:deb]) #ajout du signe oppérateur (se trouvant entre la fin de la chaine préc et le deb de la suiv)

        #stocker la variable qui se trouve après la boucle (après le dernier oppérateur)
        if not deb == len(char): #pour lessignes d'opérations sans espace entre eux (², **)
            nameVar = char[deb:]
            if not re.match('[0-9]|\.',nameVar[0]):   #si le 1er charactère n'est pas un chiffre ou un point alors c'est une variable
                print "   est une variable (commence par une lettre)"
                listVar.append((nameVar,deb,len(char)))
                list4eval.extend(("var['",nameVar,"']")) #création de la liste qui serira à la nouvelle chaine
            else :
                print "   n'est pas une variable (ne commence pas par une lettre)"
                list4eval.append(nameVar) #idem si c'est pas une variable

        #return (''.join(new_s), listVar)
        return (list4eval, listVar)

